<?php
/*
 * $Id: articles.inc,v 1.3 2002/07/04 02:17:25 t-ishii Exp $
 * 
 */
require_once("iss_mags.inc");

class articles extends dbaccess
{
  function cols() {
    return array("title" => TRUE,
		 "start_page" => TRUE,
		 "num_pages" => TRUE);
  }

  function articles() {
    dbaccess::dbaccess();
    $this->read_query =<<<EOF
     SELECT p.pb_name, m.mag_name, m.list_price,
     i.issue_date, i.price, i.total_pages,
     a.title, a.start_page, a.num_pages,
     a.articleid, a.ctid, a.iss_magid
     FROM publishers AS p, magazines AS m, iss_mags AS i, articles AS a
     WHERE  p.publisherid = m.publisherid AND
     m.magazineid = i.magazineid AND i.iss_magid = a.iss_magid
EOF;
    $this->new_reg_query =<<<EOF
     SELECT p.pb_name, m.mag_name, m.list_price,
     i.issue_date, i.price, i.total_pages,
     '' AS title, '' AS start_page, '' AS num_pages,
     '' AS articleid, '' AS ctid, i.iss_magid
     FROM publishers AS p, magazines AS m, iss_mags AS i
     WHERE  p.publisherid = m.publisherid AND
     m.magazineid = i.magazineid
EOF;
    $this->write_table = "articles";
    $this->write_cols = $this->cols();
    $this->key = array("articleid");
    $this->foreign_key = array("iss_magid" => TRUE);
    $this->parent_tables = array("iss_mags");
    $this->multi_val_cols = array("wrt_name", "keyword");
    $this->multi_val_tables = array("wrt_name" => "writers",
				    "keyword" => "keywords");
    $this->multi_val_relations = array("wrt_name" => "writings",
				    "keyword" => "articles_keywords");
    $this->multi_val_relation_cols = array("wrt_name" => array("writerid", "articleid"),
					   "keyword" => array("keywordid", "articleid"));
    $this->multi_val_values = array("wrt_name" => array(), 
				    "keyword" => array());
    $q1 =<<<EOF
      SELECT c.wrt_name FROM articles AS a,writings AS b, writers AS c
      WHERE a.articleid = b.articleid AND b.writerid = c.writerid
EOF;
    $q2 =<<<EOF
      SELECT c.keyword FROM articles AS a,articles_keywords AS b, keywords AS c
      WHERE a.articleid = b.articleid AND b.keywordid = c.keywordid
EOF;
    $this->multi_val_queries = array("wrt_name" => $q1, "keyword" => $q2);

    $q1 = "SELECT writerid AS key, wrt_name AS val FROM writers ORDER BY wrt_name";
    $q2 = "SELECT keywordid AS key, keyword AS val FROM keywords ORDER BY keyword";
    $this->multi_val_candidates_queries = array("wrt_name" => $q1, "keyword" => $q2);
  }
}

class articles_view extends iss_mags_view
{
  function articles_view() {
    iss_mags_view::iss_mags_view();
    $this->show_cols = array_merge($this->show_cols, articles::cols());
  }
}
?>
